#include <iostream>
#include "Contact.hpp"
#include <list>
#include <algorithm>

using namespace std;
using namespace reseau;

// list<Personne>::iterator it = find(lesContacts.begin(), lesContacts.end(), personne)

Contact::Contact(const Personne& Proprietaire): Proprietaire{Proprietaire} {
	cout << "Contact créé " << Proprietaire << "\n";
}

bool Contact::ajouterContact(const Personne& unContact){
	if(lesContacts.empty()){
		lesContacts.push_back(&unContact);
		cout << "Contact ajouté " << unContact <<"\n";
		return true;
	}
	if(unContact==Proprietaire)
	{
		cout << "Erreur : Contact déjà existant (Proprietaire)\n";
		return false;	
	}
	list<const Personne*>::iterator it = find(lesContacts.begin(), lesContacts.end(), &unContact);
	if(it!=lesContacts.end()) 
		cout << " Contact trouvé : " << *it << "\n";
	else 
		cout << "Erreur : Contact pas trouvé\n";
	// rechercher(unContact);
	lesContacts.push_back(&unContact);
	// for(int i=0;i<lesContacts.size();i++)
	cout << "Contact ajouté " << unContact <<"\n";
	return true;
}

bool Contact::rechercher(const Personne& unContact){
	list<const Personne*>::iterator it = find(lesContacts.begin(), lesContacts.end(),&unContact);
	if(it != lesContacts.end())
	{
		cout << "trouvé : " << unContact << "\n";
		return true;
	}
	else 
	{
		cout << "pas trouvé1\n";
		return false;
	}
	lesContacts.sort();
}

// bool Contact::supprimerContact(const Personne& unContact){
// //remove
// }


// string envoyerMessage(std::string texte, Personne p)

// string recevoirMessage(std::string texte, Personne p)

ostream& reseau::operator<<(ostream& os, Personne p){
	return os << p.getNom() << " " << p.getPrenom() << " " << p.getNumTel();
}

bool reseau::operator==(reseau::Personne p1, reseau::Personne p2){
	if(p1.getNom()==p2.getNom()){
		if(p1.getPrenom()==p2.getPrenom()){
			if(p1.getNumTel()==p2.getNumTel())
				return true;
		}
	}
	return false;
}
